unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  ExtCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Image1: TImage;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
    ccc: array[0..255] of TColor;
    xs, ys, xe, ye: double;
    lw, lh: word;
    iteration: word;
    bailout: double;
    function calcMandelBrot(X, Y: double): word;
    procedure RectMandelBrot;
  end;

var
  Form1: TForm1;

implementation

{ TForm1 }

function RGB(r, g, b: Byte): TCOLOR;
begin
  Result := (r or (g shl 8) or (b shl 16));
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  i: Integer;
begin
  for i := 0 to 255 do
    ccc[i] := RGB(i*3,i*7,i*5);
  iteration := 100;
  bailout := 4;
  xs := -2.5;
  ys := -2.5;
  xe := 2.5;
  ye := 2.5;
  lw := Image1.Width;
  lh := Image1.Height;
end;

function TForm1.calcMandelBrot(X, Y: double): word;
var
  xx, yy, tx, ty: double;
  i: word;
begin
  xx := 0;
  yy := 0;
  i := 0;
  while ((xx * xx + yy * yy) < bailout)and(i < iteration) do
  begin
    tx := xx * xx - yy * yy + x;
    ty := 2 * xx * yy + y;
    xx := tx;
    yy := ty;
    i := i + 1;
  end;
  result := i;
end;

procedure TForm1.RectMandelBrot;
var
  i, j: word;
  X, Y: double;
  lx, ly: double;
begin
  lx := xe - xs;
  ly := ye - ys;
  for j := 0 to lh - 1 do
  begin
    for i := 0 to lw - 1 do
    begin
      X := xs + i * lx / lw;
      Y := ys + j * ly / lh;
      Image1.Canvas.Pixels[i, j] := ccc[calcMandelBrot(X, Y) mod 256];
    end;
  end;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  Image1.Picture := nil;
  lw := Image1.Width;
  lh := Image1.Height;
  RectMandelBrot;
end;

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  lx, ly: double;
begin
  lx := xe - xs;
  ly := ye - ys;
  Caption := Format('%f, %f', [xs + X * lx / lw,ys + Y * ly / lh]);
end;


initialization
  {$I unit1.lrs}

end.

